function dr=model(t,U)

Vms=U(1); 
ms=U(2);
hs=U(3);
ssts=U(4);
m_Ito_fast=U(5);
h_Ito_fast=U(6);
Cast=U(7);
Vmt=U(8);
mt=U(9);
ht=U(10);
sstt=U(11);
qs=U(12);
qt=U(13);
Kt_1=U(14);
Nat=U(15);
Cat_1=U(16);
Nast=U(17);
Kst=U(18);
BTRH=U(19);
BTRL=U(20);
CaSRup=U(21);
CaSRrel_c=U(22);
Cadt=U(23);
F1t=U(24);
F2t=U(25);
F3t=U(26);
F4t=U(27);
m_Ito_slow=U(28);
Cst=U(29);
CMDds=U(30);
VDI_s=U(31);
C3=U(32);
C4=U(33);
VDA_s=U(34);
CDI_ss=U(35);
Cca1=U(36);
Cca2=U(37);
Cca3=U(38);
Cca4=U(39);
Ccao=U(40);
ys=U(41);
TCst=U(42);
CMDss=U(43);
VDI_t=U(44);
TC3=U(45);
TC4=U(46);
VDA_t=U(47);
CDI_ds=U(48);
TCca1=U(49);
TCca2=U(50);
TCca3=U(51);
TCca4=U(52);
TCcao=U(53);
yt=U(54);
rt=U(55);
st=U(56);
h_Ito_slow=U(57);
rsts=U(58);
rstt=U(59);
ExBUFFERdt_free=U(60);
ExBUFFERdt_Ca=U(61);
ExBUFFERst_free=U(62);
ExBUFFERst_Ca=U(63);
Cac=U(64);
Nac=U(65);
Kc=U(66);
ExBUFFERc_free=U(67);
ExBUFFERc_Ca=U(68);
CaSRrel_s=U(69);    
F1s=U(70); 
F2s=U(71); 
F3s=U(72);     
F4s=U(73);  
Cads=U(74); 
Kss=U(75);
Nass=U(76); 
Cass=U(77);
ExBUFFERds_free=U(78);
ExBUFFERds_Ca=U(79);
ExBUFFERss_free=U(80);
ExBUFFERss_Ca=U(81);
Cat_2=U(82);
Cat_3=U(83);
Cat_4=U(84);
Cat_5=U(85);
Cat_6=U(86);
Cat_7=U(87);
Cat_8=U(88);
Cat_9=U(89);
Kt_2=U(90);
Kt_3=U(91);
Kt_4=U(92);
Kt_5=U(93);
Kt_6=U(94);
Kt_7=U(95);
Kt_8=U(96);
Kt_9=U(97);



%*****Global variables*****
global R T F Vel Rel Const_1
global Smtot Sms Smt Cms Cmt
global Nae Cae Ke BTRHmax BTRLmax ATPi ExBUFFERp Cap Achs
global gNa gNas PKsCa PKsCas gK1 gK1s gKb gKbs PKto PKtos PKss PKsss gKach gKachs gKsNa gKsNas gKatp gKatps gNab gNabs gCab gCabs 
global INaCamax INaCamaxs INaCamaxds INaKmax INaKmaxs IpCamax IpCamaxs  
global PCa PCas PCads PNal PNals PKl PKls PnsNa PnsNas PnsK PnsKs 
global fCads fNaCads fVSRrel_c 
global t0 
global VCLAMP STIMULATION DIALYSIS



%*****Volume of myocyte [ml]*****
Vcell=Smtot/Const_1;

%*****Volumes of dyadic spaces [ml]*****
Vd_s=Vcell*0.00001275;
Vd_t=0; 

%*****Volumes of submembrane spaces [ml]*****
Vs_s=Vcell*0.01;
Vs_t=0; 

%*****Volume of cytosol [ml]*****
Vc=Vcell*0.585*0.966; 

%*****Volume of NSR [ml]*****
VSRup=Vcell*0.0315;

%*****Volumes of JSR [ml]*****
VSRrel_s=Vcell*0.0035*(1-fVSRrel_c);
VSRrel_c=Vcell*0.0035*fVSRrel_c;

%*****Surface membrane area [cm^2]*****
Sms=Smtot;

%*****T-tubular membrane area [cm^2]*****
Smt=0;

%*****Surface membrane capacitance [uF]*****
Cms=Sms;

%*****T-tubular membrane capacitance [uF]*****
Cmt=0;

%*****Ion conductivities, permeabilities or maximum currents*****  
gNas=gNa*Smtot;                         gNat=0;    
gKachs=gKach*Smtot;                     gKacht=0;       
PKsss=PKss*Smtot;                       PKsst=0;       
gK1s=gK1*Smtot;                         gK1t=0;    
gKbs=gKb*Smtot;                         gKbt=0;    
PKtos=PKto*Smtot;                       PKtot=0;
PKsCas=PKsCa*Smtot;                     PKsCat=0; 
gKsNas=gKsNa*Smtot;                     gKsNat=0;    
gNabs=gNab*Smtot;                       gNabt=0;    
gCabs=gCab*Smtot;                       gCabt=0;    
gKatps=gKatp*Smtot;                     gKatpt=0;
PCas=PCa*Smtot*(1-fCads);               PCat=0;
PCads=PCa*Smtot*fCads; 
PNals=PNal*Smtot;                       PNalt=0;    
PKls=PKl*Smtot;                         PKlt=0;    
PnsNas=PnsNa*Smtot;                     PnsNat=0;
PnsKs=PnsK*Smtot;                       PnsKt=0;
INaCamaxs=INaCamax*Smtot*(1-fNaCads);   INaCamaxt=0; 
INaCamaxds=INaCamax*Smtot*fNaCads;
INaKmaxs=INaKmax*Smtot;                 INaKmaxt=0;
IpCamaxs=IpCamax*Smtot;                 IpCamaxt=0;
                    
              

%*****IONIC CURRENTS*************
%*****Stimulation pulse [uA]*****
if STIMULATION==1 && VCLAMP==0 && (t-t0)<0.001 
   IKext=52*(Smtot);  % 150% of threshold 
else
   IKext=0;
end;


%*****Fast sodium current [uA]*****
%Surface
ENas=log(Nae/Nass)*R*T/F;
ams=117.26*(Vms+59.3)./(1-exp(-0.55*(Vms+59.3)));
bms=3800*exp(-0.072*(Vms+61));
ahs=284.4./(1+exp(0.0812*(Vms+115.9)));
bhs=18.77*(Vms+64.4)./(1-exp(-0.22*(Vms+64.4)));
dms=(ams*(1-ms)-bms*ms);
dhs=(ahs*(1-hs)-bhs*hs);
INas=gNas*ms^3*hs*(Vms-log((Nae+0.12*Ke)/(Nass+0.12*Kc))*R*T/F);
%T-tubules
amt=0;
bmt=0;
aht=0;
bht=0;
dmt=0;
dht=0;
INat=0;


%*****Currents through L-type Ca-channels [uA]*****
%Calcium L-type current
%Surface
ECas=log(Cae/Cass)*R*T/(2*F);
%voltage dependent activation
VDAinf_s=1/(1+exp(-(Vms+15.3)/5));
VDAtau_s=(0.00025+0.00305*exp(-0.0045*(Vms+7)^2)+0.00105*exp(-0.002*(Vms-18)^2));
dVDA_s=(VDAinf_s-VDA_s)/VDAtau_s;
dVDA_t=0;
%voltage dependent inactivation
VDIinf_s=1/(1+exp((Vms+26.7)/5.4));
VDItau_s=0.36*1.15*(0.041*exp(-((Vms+47)/12)^2)+0.08/(1+exp(-(Vms+55)/5))+0.015/(1+exp((Vms+75)/25)));
dVDI_s=(VDIinf_s-VDI_s)/VDItau_s;
dVDI_t=0;
%Ca buffering by calmoduline
dCMDss=100000*Cass*(1-CMDss)-238*CMDss;
dTCst=0;
%Ca buffering by sarcolemma
dTC3=0;
dTC4=0;
%Ca dependent inactivation
CDIinf_ss=1/(1+0.244*(CMDss.^4+0.318^4)/CMDss.^4);
CDItau_ss=0.004+(0.043-0.014)/(1+exp((CMDss-0.77)/0.075));
%CDItau_ss=0.0005+(0.029-0.0005)/(1+exp((CMDss-0.77)/0.07));
dCDI_ss=(CDIinf_ss-CDI_ss)/CDItau_ss;
dTCca1=0;
dTCca2=0;
dTCca3=0;
dTCca4=0;
dTCcao=0;
dyt=0;
ICas=PCas*4*(Vms*F^2/(R*T))*(0.001*exp(2*Vms*F/(R*T))-0.341*Cae)/(exp(2*Vms*F/(R*T))-1)*VDA_s*VDI_s*(1-CDI_ss); 
%Surface dyadic 
%Ca buffering by calmoduline
dCMDds=100000*Cads*(1-CMDds)-238*CMDds;
dCst=0;
dC3=0;
dC4=0;
%Ca dependent inactivation
CDIinf_ds=1/(1+0.244*(CMDds.^4+0.318^4)/CMDds.^4);
CDItau_ds=0.004+(0.043-0.014)/(1+exp((CMDds-0.77)/0.075));
%CDItau_ds=0.0005+(0.029-0.0005)/(1+exp((CMDds-0.77)/0.07));
dCDI_ds=(CDIinf_ds-CDI_ds)/CDItau_ds;
dCca1=0;
dCca2=0;
dCca3=0;
dCca4=0;
dCcao=0;
dys=0;
ICads=PCads*4*(Vms*F^2/(R*T))*(0.001*exp(2*Vms*F/(R*T))-0.341*Cae)/(exp(2*Vms*F/(R*T))-1)*VDA_s*VDI_s*(1-CDI_ds); 
%T-tubules 
ICat=0;
%T-tubules dyadic 
ICadt=0;

%Potasium L-type current
%Surface
IKls=0;
%T-tubules
IKlt=0;

%Sodium L-type current
%Surface
INals=0;
%T-tubules
INalt=0;


%*****Time-dependent transient outward potassium current [uA]*****
%Surface
EKs=log(Ke/Kc)*R*T/F;
alpha_m_Ito_fast=1000/(1.4*exp(Vms/(-14241))+0.35*exp(Vms/(-15)));
beta_m_Ito_fast=1000/(22.7*exp(Vms/37.9)+1775*exp(Vms/8.4));
alpha_h_Ito_fast=1000/(2.5*exp(Vms/3.2)+2195*exp(Vms/23.6));	
beta_h_Ito_fast=1000/(40.4*exp(Vms/(-76022))+0.29*exp(Vms/(-5.4))); 
alpha_m_Ito_slow=1000/(0.0002*exp(Vms/(-7.2))+1.37*exp(Vms/(-47.8)));
beta_m_Ito_slow=1000/(1346*exp(Vms/16)+1600*exp(Vms/11.3));
alpha_h_Ito_slow=1000/(6613*exp(Vms/135222)+143392*exp(Vms/12.1));	
beta_h_Ito_slow=1000/(4801*exp(Vms/(-125))+119*exp(Vms/(-10.3)));
dm_Ito_fast=(alpha_m_Ito_fast*(1-m_Ito_fast)-beta_m_Ito_fast*m_Ito_fast); 
dh_Ito_fast=(alpha_h_Ito_fast*(1-h_Ito_fast)-beta_h_Ito_fast*h_Ito_fast);
dm_Ito_slow=(alpha_m_Ito_slow*(1-m_Ito_slow)-beta_m_Ito_slow*m_Ito_slow); 
dh_Ito_slow=(alpha_h_Ito_slow*(1-h_Ito_slow)-beta_h_Ito_slow*h_Ito_slow);
IKtos_fast=PKtos*F^2/(R*T)*Vms*(Kc-Ke*exp(-Vms*F/(R*T)))/(1-exp(-Vms*F/(R*T)))*m_Ito_fast*h_Ito_fast;
IKtos_slow=PKtos*0.62*F^2/(R*T)*Vms*(Kc-Ke*exp(-Vms*F/(R*T)))/(1-exp(-Vms*F/(R*T)))*m_Ito_slow*h_Ito_slow;
IKtos=IKtos_fast+IKtos_slow;
%T-tubules
drt=0; 
dst=0; 
IKtot=0;


%*****Steady-state outward potassium current [uA]*****
%Surface
rstinfs=1/(1+exp(-(Vms+3)/27));
drsts=0; 
dssts=0; 
IKsss=PKsss*F^2/(R*T)*Vms*(Kc-Ke*exp(-Vms*F/(R*T)))/(1-exp(-Vms*F/(R*T)))*rstinfs;
%T-tubules
drstt=0; 
dsstt=0;
IKsst=0;


%*****Acetylcholine-activated potassium current [uA]*****
%Surface
dqs=0;
IKachs=gKachs*(1+18.75/(1+0.00913652^0.47781/Achs^0.47781))/(1+exp((Vms+145.699)/41.66))*(Vms-EKs);
%T-tubules
dqt=0;
IKacht=0;


%*****Inwardly rectifying potassium current [uA]*****
%Surface
IK1s=gK1s*(Vms-EKs)/(1+exp(2.04*F/(R*T)*(Vms-EKs))*(1.0+exp((Ke-0.9988)/-0.124)));
%T-tubules
IK1t=0;


%*****Na-activated potassium current [uA]*****
%Surface
IKsNas=gKsNas*(0.8-(0.65./(1+exp((Vms+125)/15)))).*0.85./(1+(66./Nass)^2.8)*(Vms-EKs);
%T-tubules   
IKsNat=0;


%*****Ca-activared potassium current [uA]*****
%Surface
IKsCas=PKsCas*F^2/(R*T)*Vms*(Kc-Ke*exp(-Vms*F/(R*T)))/(1-exp(-Vms*F/(R*T)))/(1+(0.002/Cass)^4);
%T-tubules
IKsCat=0;


%*****Nonspecific Ca-activated sodium current [uA]*****
%Surface
InsNas=PnsNas*Vms*F^2/(R*T)*(0.75*Nass*exp(Vms*F/(R*T))-0.75*Nae)/(exp(Vms*F/(R*T))-1)/(1+(0.0025/Cass)^3);
%T-tubules  
InsNat=0;


%*****Nonspecific Ca-activated potassium current [uA]*****
%Surface
InsKs=PnsKs*Vms*F^2/(R*T)*(0.75*Kc*exp(Vms*F/(R*T))-0.75*Ke)/(exp(Vms*F/(R*T))-1)/(1+(0.0025/Cass)^3);
%T-tubules  
InsKt=0;


%*****Background sodium current [uA]*****
%Surface
INabs=gNabs*(Vms-ENas);
%T-tubules  
INabt=0;


%*****Background calcium current [uA]*****
%Surface
ICabs=gCabs*(Vms-ECas);
%T-tubules  
ICabt=0;


%*****Background potassium current [uA]*****
%Surface
IKbs=gKbs*(Vms-EKs);
%T-tubules   
IKbt=0;


%*****Na/Ca-exchange current [uA]*****
%Surface
INaCas=INaCamaxs*(exp(0.0187*Vms)*Nass^3*Cae-exp(-0.0187*Vms)*Nae^3*Cass)/(1+0.0001*(Nae^3*Cass+Nass^3*Cae));
%Surface dyads    
INaCads=INaCamaxds*(exp(0.0187*Vms)*Nass^3*Cae-exp(-0.0187*Vms)*Nae^3*Cads)/(1+0.0001*(Nae^3*Cads+Nass^3*Cae));
%T-tubules
INaCat=0;
%T-tubules dyadic
INaCadt=0;


%*****Na/K-exchange current [uA]*****
%Surface
INaKs=INaKmaxs/(1+0.1245*exp(-0.1*Vms*F/(R*T))+0.0365*1/7*(exp(Nae/67.3)-1)*exp(-Vms*F/(R*T)))*1/(1+(10/Nass)^2)*Ke/(Ke+1.5);
%T-tubules  
INaKt=0;


%*****Sarcolemmal calcium pump current[uA]*****
%Surface
IpCas=IpCamaxs*Cass/(0.0004+Cass);
%T-tubules  
IpCat=0;


%*****ATP-dependent potassium current [uA]*****
%Surface
IKatps=gKatps*1/(1+(ATPi/0.114)^2)*(Ke/4)^0.24*(Vms-EKs);  
%T-tubules  
IKatpt=0;



%*****IONIC FLUXES********************
%*****Ca uptake into NSR [umol/s]*****
JCaSRup=Vc*0.296066*((Cac/0.000168)^1.2-(CaSRup/1.176)^1.287)/(1+(Cac/0.000168)^1.2+(CaSRup/1.176)^1.287);


%*****Ca translocation from NSR to JSR and CSR [umol/s]*****
Tau_SRCa_tr=0.02;
JCaSRtr_s=VSRrel_s/Tau_SRCa_tr*(CaSRup-CaSRrel_s);
JCaSRtr_c=VSRrel_c/Tau_SRCa_tr*(CaSRup-CaSRrel_c);


%*****Ca-induced Ca release from JSR [umol/s]*****
%Surface dyads
kims=5;
koms=60;
kiCas=500;
koCas=10000*5;
kCaSRs=15-(15-1)/(1+(0.45/CaSRrel_s)^2.5);
koSRCas=koCas/kCaSRs;
kiSRCas=kiCas*kCaSRs;
dF1s=F2s*koms+F4s*kims-F1s*(kiSRCas*Cads+koSRCas*Cads^2);
dF2s=F1s*koSRCas*Cads^2+F3s*kims-F2s*(kiSRCas*Cads+koms);
dF3s=F2s*kiSRCas*Cads+F4s*koSRCas*Cads^2-F3s*(kims+koms);
dF4s=F3s*koms+F1s*kiSRCas*Cads-F4s*(koSRCas*Cads^2+kims);
JCaSRrel_s=2*25000*10*VSRrel_s*F2s*(CaSRrel_s-Cads);
%Deeper cytoplasm 
kimt=5;
komt=60;
kiCat=500;
koCat=10000*5*5;
kCaSRt=15-(15-1)/(1+(0.45/CaSRrel_c)^2.5);
koSRCat=koCat/kCaSRt;
kiSRCat=kiCat*kCaSRt;
dF1t=F2t*komt+F4t*kimt-F1t*(kiSRCat*Cass+koSRCat*Cass^2);
dF2t=F1t*koSRCat*Cass^2+F3t*kimt-F2t*(kiSRCat*Cass+komt);
dF3t=F2t*kiSRCat*Cass+F4t*koSRCat*Cass^2-F3t*(kimt+komt);
dF4t=F3t*komt+F1t*kiSRCat*Cass-F4t*(koSRCat*Cass^2+kimt);
JCaSRrel_c=2*25000*10*VSRrel_c*F2t*(CaSRrel_c-Cass);



%*****Ca BINDING TO TROPONIN*****************************
%*****Ca binding to troponin high affinity sites [-]*****
dBTRH=20000*Cac*(1-BTRH)-0.07*BTRH;

%*****Ca binding to troponin low affinity sites [-]******
dBTRL=40000*Cac*(1-BTRL)-BTRL*40;



%*****Ca BUFFERING BY BAPTA OR EGTA*************
%*****Parameters of external buffer - BAPTA*****
Ext_Buffer_Kon=500000; Ext_Buffer_Koff=80; 
Ext_Buffer_Taudtst=0.0003399; Ext_Buffer_Taudsss=0.0003399*7.4; Ext_Buffer_Taustc=0.00325; Ext_Buffer_Taussc=0.00175; Ext_Buffer_Taussst=0.1; Ext_Buffer_Taupss=200*Vs_s/(Vc+Vs_s+Vs_t);
   
%*****Parameters of external buffer - EGTA******
%Ext_Buffer_Kon=5000; Ext_Buffer_Koff=0.75; 
%Ext_Buffer_Taudtst=0.0003399; Ext_Buffer_Taudsss=0.0003399*7.4; Ext_Buffer_Taustc=0.00325; Ext_Buffer_Taussc=0.00175; Ext_Buffer_Taussst=0.1; Ext_Buffer_Taupss=200*Vs_s/(Vc+Vs_s+Vs_t);

ExBUFFERp_Ca=ExBUFFERp*Cap/(Cap+0.00015);
ExBUFFERp_free=ExBUFFERp-ExBUFFERp_Ca;

%*****ExBUFFER free concentration in subspaces [mM]*****
dExBUFFERst_free=0;
dExBUFFERss_free=-Ext_Buffer_Kon*ExBUFFERss_free*Cass+Ext_Buffer_Koff*ExBUFFERss_Ca-(ExBUFFERss_free-ExBUFFERds_free)/Ext_Buffer_Taudsss-(ExBUFFERss_free-ExBUFFERc_free)/Ext_Buffer_Taussc*(Vc/Vs_s)+DIALYSIS*(ExBUFFERp_free-ExBUFFERss_free)/Ext_Buffer_Taupss;

%*****ExBUFFER_Ca concentration in subspaces [mM]*****
dExBUFFERst_Ca=0;
dExBUFFERss_Ca=Ext_Buffer_Kon*ExBUFFERss_free*Cass-Ext_Buffer_Koff*ExBUFFERss_Ca-(ExBUFFERss_Ca-ExBUFFERds_Ca)/Ext_Buffer_Taudsss-(ExBUFFERss_Ca-ExBUFFERc_Ca)/Ext_Buffer_Taussc*(Vc/Vs_s)+DIALYSIS*(ExBUFFERp_Ca-ExBUFFERss_Ca)/Ext_Buffer_Taupss;

%*****ExBUFFER free concentration in dyadic spaces [mM]*****
dExBUFFERdt_free=0;
dExBUFFERds_free=-Ext_Buffer_Kon*ExBUFFERds_free*Cads+Ext_Buffer_Koff*ExBUFFERds_Ca+(ExBUFFERss_free-ExBUFFERds_free)/Ext_Buffer_Taudsss*(Vs_s/Vd_s);

%*****ExBUFFER_Ca concentration in dyadic spaces [mM]*****
dExBUFFERdt_Ca=0;
dExBUFFERds_Ca=Ext_Buffer_Kon*ExBUFFERds_free*Cads-Ext_Buffer_Koff*ExBUFFERds_Ca+(ExBUFFERss_Ca-ExBUFFERds_Ca)/Ext_Buffer_Taudsss*(Vs_s/Vd_s);

%*****ExBUFFER free concentration in bulk cytosol [mM]*****
dExBUFFERc_free=-Ext_Buffer_Kon*ExBUFFERc_free*Cac+Ext_Buffer_Koff*ExBUFFERc_Ca+(ExBUFFERss_free-ExBUFFERc_free)/Ext_Buffer_Taussc;

%*****ExBUFFER_Ca concentration in bulk cytosol [mM]*****
dExBUFFERc_Ca=Ext_Buffer_Kon*ExBUFFERc_free*Cac-Ext_Buffer_Koff*ExBUFFERc_Ca+(ExBUFFERss_Ca-ExBUFFERc_Ca)/Ext_Buffer_Taussc;



%*****IONIC CONCENTRATIONS*************
%*****Ca concentration in NSR [mM]*****
dCaSRup=(JCaSRup-JCaSRtr_c-JCaSRtr_s)/VSRup;

%*****Ca concentrations in JSR [mM]*****
dCaSRrel_s=1/(1+15*0.65/(0.65+CaSRrel_s)^2)*(JCaSRtr_s-JCaSRrel_s)/VSRrel_s;
dCaSRrel_c=1/(1+15*0.65/(0.65+CaSRrel_c)^2)*(JCaSRtr_c-JCaSRrel_c)/VSRrel_c;


%*****Ca concentration in dyadic spaces [mM]*****
%Surface
Tau_ssds=1.08975e-006; 
JCassds=(Cass-Cads)*Vd_s/Tau_ssds;
dCads=(ICads-2*INaCads)/(-2*F*Vd_s)+JCaSRrel_s/Vd_s+JCassds/Vd_s-dCMDds*0.05-Ext_Buffer_Kon*ExBUFFERds_free*Cads+Ext_Buffer_Koff*ExBUFFERds_Ca;
%T-tubules
dCadt=0;


%*****Ca concentration in submembrane spaces [mM]*****
%Surface
Tau_Ca_pss=4.42; 
Tau_Ca_css=4.00362319E-5; %Tau_Ca_ssc=1.75e-3s
JCapss=(Cap-Cass)*Vs_s/Tau_Ca_pss*DIALYSIS;
JCacss=(Cac-Cass)*Vs_s/Tau_Ca_css;
%dCass=1/(1+0.05*0.00238/(0.00238+Cass)^2)*((ICas-2*INaCas+ICabs+IpCas)/(-2*F*Vs_s)+(JCapss-JCassds+JCacss)/Vs_s+JCaSRrel_c/Vs_s-Ext_Buffer_Kon*ExBUFFERss_free*Cass+Ext_Buffer_Koff*ExBUFFERss_Ca);
dCass=((ICas-2*INaCas+ICabs+IpCas)/(-2*F*Vs_s)+(JCapss-JCassds+JCacss)/Vs_s+JCaSRrel_c/Vs_s-dCMDss*0.05-Ext_Buffer_Kon*ExBUFFERss_free*Cass+Ext_Buffer_Koff*ExBUFFERss_Ca);
%T-tubules
dCast=0;

%*****K concentration in submembrane spaces [mM]*****
%Surface
Tau_K_css=4.00362319E-5; 
JKcss=(Kc-Kss)*Vs_s/Tau_K_css;
dKss=-(-IKext+IKachs+IKsss+IK1s+IKbs+IKls+IKsNas+IKsCas+InsKs-2*INaKs+IKatps+IKtos)/(F*Vs_s)+JKcss/Vs_s;
%T-tubules
dKst=0;

%*****Na concentration in submembrane spaces [mM]*****
%Surface
Tau_Na_css=4.00362319E-5; 
JNacss=(Nac-Nass)*Vs_s/Tau_Na_css;
dNass=-(INas+INals+InsNas+INabs+3*INaCas+3*INaKs)/(F*Vs_s)+JNacss/Vs_s;
%T-tubules
dNast=0;


%*****Ca concentration in bulk cytosol [mM]*****
dCac=1/(1+0.05*0.00238/(0.00238+Cac)^2)*((-JCacss-JCaSRup)/Vc-Ext_Buffer_Kon*ExBUFFERc_free*Cac+Ext_Buffer_Koff*ExBUFFERc_Ca-dBTRH*BTRHmax-dBTRL*BTRLmax);

%*****K concentration in bulk cytosol [mM]*****
dKc=-(JKcss)/Vc;

%*****Na concentration in bulk cytosol [mM]*****
dNac=-(JNacss)/Vc;


%*****Ca concentrations in T-tubules [mM]*****
dCat_1=0; 
dCat_2=0;
dCat_3=0;
dCat_4=0;
dCat_5=0;
dCat_6=0;
dCat_7=0;
dCat_8=0;
dCat_9=0;

%*****K concentrations in T-tubules [mM]*****
dKt_1=0;
dKt_2=0;
dKt_3=0;
dKt_4=0;
dKt_5=0;
dKt_6=0;
dKt_7=0;
dKt_8=0;
dKt_9=0;

%*****Na concentration in T-tubules [mM]*****
dNat=0;



%*****MEMBRANE VOLTAGE*********************************
%*****Membrane voltage in current clamp conditions*****
if VCLAMP==0 
dVms=1000*(IKext-INas-IKsCas-ICas-ICads-INals-IKls-IKachs-IKsss-IK1s-IKbs-IKsNas-IKatps-InsNas-InsKs-INabs-ICabs-INaCas-INaKs-IpCas-IKtos)/Cms;
dVmt=0;
end;


%*****Membrane voltage in voltage clamp conditions*****
if VCLAMP==1 
dVms=1000*(1000*(Vel-Vms)/Rel-INas-IKsCas-ICas-ICads-INals-IKls-IKsss-IKachs-IK1s-IKbs-IKsNas-IKatps-InsNas-InsKs-INabs-ICabs-INaCas-INaKs-IpCas-IKtos)/Cms;
dVmt=0;
end;



dr=[dVms; dms; dhs; dssts; dm_Ito_fast; dh_Ito_fast; dCast; dVmt; dmt; dht; dsstt; dqs; dqt; dKt_1; dNat; dCat_1; dNast; dKst; dBTRH; dBTRL; dCaSRup; dCaSRrel_c; dCadt; dF1t; dF2t; dF3t; dF4t; dm_Ito_slow; dCst; dCMDds; dVDI_s; dC3; dC4; dVDA_s; dCDI_ss; dCca1; dCca2; dCca3; dCca4; dCcao; dys; dTCst; dCMDss; dVDI_t; dTC3; dTC4; dVDA_t; dCDI_ds; dTCca1; dTCca2; dTCca3; dTCca4; dTCcao; dyt; drt; dst; dh_Ito_slow; drsts; drstt; dExBUFFERdt_free; dExBUFFERdt_Ca; dExBUFFERst_free; dExBUFFERst_Ca; dCac; dNac; dKc; dExBUFFERc_free; dExBUFFERc_Ca; dCaSRrel_s; dF1s; dF2s; dF3s; dF4s; dCads; dKss; dNass; dCass; dExBUFFERds_free; dExBUFFERds_Ca; dExBUFFERss_free; dExBUFFERss_Ca; dCat_2; dCat_3; dCat_4; dCat_5; dCat_6; dCat_7; dCat_8; dCat_9; dKt_2; dKt_3; dKt_4; dKt_5; dKt_6; dKt_7; dKt_8; dKt_9];