options=odeset('InitialStep',InitialStep,'MaxStep',MaxStep,'RelTol',TOL,'Refine',Refinement);
[Tt,Uo]=ode15s('model',[t0 tend],[Vms0; ms0; hs0; ssts0; m_Ito_fast0; h_Ito_fast0; Cast0; Vmt0; mt0; ht0; sstt0; qs0; qt0; Kt_10; Nat0; Cat_10; Nast0; Kst0; BTRH0; BTRL0; CaSRup0; CaSRrel_c0; Cadt0; F1t0; F2t0; F3t0; F4t0; m_Ito_slow0; Cst0; CMDds0; VDI_s0; C30; C40; VDA_s0; CDI_ss0; Cca10; Cca20; Cca30; Cca40; Ccao0; ys0; TCst0; CMDss0; VDI_t0; TC30; TC40; VDA_t0; CDI_ds0; TCca10; TCca20; TCca30; TCca40; TCcao0; yt0; rt0; st0; h_Ito_slow0; rsts0; rstt0; ExBUFFERdt_free0; ExBUFFERdt_Ca0; ExBUFFERst_free0; ExBUFFERst_Ca0; Cac0; Nac0; Kc0; ExBUFFERc_free0; ExBUFFERc_Ca0; CaSRrel_s0; F1s0; F2s0; F3s0; F4s0; Cads0; Kss0; Nass0; Cass0; ExBUFFERds_free0; ExBUFFERds_Ca0; ExBUFFERss_free0; ExBUFFERss_Ca0; Cat_20; Cat_30; Cat_40; Cat_50; Cat_60; Cat_70; Cat_80; Cat_90; Kt_20; Kt_30; Kt_40; Kt_50; Kt_60; Kt_70; Kt_80; Kt_90],options);

  Vms=Uo(:,1);
  ms=Uo(:,2);
  hs=Uo(:,3);
  ssts=Uo(:,4);
  m_Ito_fast=Uo(:,5);
  h_Ito_fast=Uo(:,6);
  Cast=Uo(:,7);
  Vmt=Uo(:,8);
  mt=Uo(:,9);
  ht=Uo(:,10);
  sstt=Uo(:,11);
  qs=Uo(:,12);
  qt=Uo(:,13);
  Kt_1=Uo(:,14);
  Nat=Uo(:,15);
  Cat_1=Uo(:,16);
  Nast=Uo(:,17);
  Kst=Uo(:,18);
  BTRH=Uo(:,19);
  BTRL=Uo(:,20);
  CaSRup=Uo(:,21);
  CaSRrel_c=Uo(:,22);
  Cadt=Uo(:,23);
  F1t=Uo(:,24);  
  F2t=Uo(:,25);  
  F3t=Uo(:,26);  
  F4t=Uo(:,27);  
  m_Ito_slow=Uo(:,28);
  Cst=Uo(:,29);
  CMDds=Uo(:,30);
  VDI_s=Uo(:,31);
  C3=Uo(:,32);
  C4=Uo(:,33);
  VDA_s=Uo(:,34);
  CDI_ss=Uo(:,35);
  Cca1=Uo(:,36);
  Cca2=Uo(:,37);
  Cca3=Uo(:,38);
  Cca4=Uo(:,39);
  Ccao=Uo(:,40);
  ys=Uo(:,41);
  TCst=Uo(:,42);
  CMDss=Uo(:,43);
  VDI_t=Uo(:,44);
  TC3=Uo(:,45);
  TC4=Uo(:,46);
  VDA_t=Uo(:,47);
  CDI_ds=Uo(:,48);
  TCca1=Uo(:,49);
  TCca2=Uo(:,50);
  TCca3=Uo(:,51);
  TCca4=Uo(:,52);
  TCcao=Uo(:,53);
  yt=Uo(:,54);
  rt=Uo(:,55);
  st=Uo(:,56);
  h_Ito_slow=Uo(:,57);
  rsts=Uo(:,58);
  rstt=Uo(:,59);
  ExBUFFERdt_free=Uo(:,60);
  ExBUFFERdt_Ca=Uo(:,61);
  ExBUFFERst_free=Uo(:,62);
  ExBUFFERst_Ca=Uo(:,63);
  Cac=Uo(:,64);
  Nac=Uo(:,65);
  Kc=Uo(:,66);
  ExBUFFERc_free=Uo(:,67);
  ExBUFFERc_Ca=Uo(:,68);
  CaSRrel_s=Uo(:,69);    
  F1s=Uo(:,70); 
  F2s=Uo(:,71); 
  F3s=Uo(:,72);     
  F4s=Uo(:,73);  
  Cads=Uo(:,74); 
  Kss=Uo(:,75);
  Nass=Uo(:,76); 
  Cass=Uo(:,77);
  ExBUFFERds_free=Uo(:,78);
  ExBUFFERds_Ca=Uo(:,79);
  ExBUFFERss_free=Uo(:,80);
  ExBUFFERss_Ca=Uo(:,81);
  Cat_2=Uo(:,82);
  Cat_3=Uo(:,83);
  Cat_4=Uo(:,84);
  Cat_5=Uo(:,85);
  Cat_6=Uo(:,86);
  Cat_7=Uo(:,87);
  Cat_8=Uo(:,88);
  Cat_9=Uo(:,89);
  Kt_2=Uo(:,90);
  Kt_3=Uo(:,91);
  Kt_4=Uo(:,92);
  Kt_5=Uo(:,93);
  Kt_6=Uo(:,94);
  Kt_7=Uo(:,95);
  Kt_8=Uo(:,96);
  Kt_9=Uo(:,97);
  
  
  
%Initial conditions***
Vms0=Vms(length(Vms));
ms0=ms(length(ms));
hs0=hs(length(hs));
ssts0=ssts(length(ssts));
m_Ito_fast0=m_Ito_fast(length(m_Ito_fast));
h_Ito_fast0=h_Ito_fast(length(h_Ito_fast));
m_Ito_slow0=m_Ito_slow(length(m_Ito_slow));
Cst0=Cst(length(Cst));
CMDds0=CMDds(length(CMDds));
VDI_s0=VDI_s(length(VDI_s));
C30=C3(length(C3));
C40=C4(length(C4));
VDA_s0=VDA_s(length(VDA_s));
CDI_ss0=CDI_ss(length(CDI_ss));
Cca10=Cca1(length(Cca1));
Cca20=Cca2(length(Cca2));
Cca30=Cca3(length(Cca3));
Cca40=Cca4(length(Cca4));
Ccao0=Ccao(length(Ccao));
ys0=ys(length(ys));
Cast0=Cast(length(Cast));
Vmt0=Vmt(length(Vmt));
mt0=mt(length(mt));
ht0=ht(length(ht));
sstt0=sstt(length(sstt));
qs0=qs(length(qs));
qt0=qt(length(qt));
TCst0=TCst(length(TCst));
CMDss0=CMDss(length(CMDss));
VDI_t0=VDI_t(length(VDI_t));
TC30=TC3(length(TC3));
TC40=TC4(length(TC4));
VDA_t0=VDA_t(length(VDA_t));
CDI_ds0=CDI_ds(length(CDI_ds));
TCca10=TCca1(length(TCca1));
TCca20=TCca2(length(TCca2));
TCca30=TCca3(length(TCca3));
TCca40=TCca4(length(TCca4));
TCcao0=TCcao(length(TCcao));
yt0=yt(length(yt));
Kt_10=Kt_1(length(Kt_1));
Nat0=Nat(length(Nat));
Cat_10=Cat_1(length(Cat_1));
Nast0=Nast(length(Nast));
Kst0=Kst(length(Kst));
BTRH0=BTRH(length(BTRH));
BTRL0=BTRL(length(BTRL));
CaSRup0=CaSRup(length(CaSRup));
CaSRrel_c0=CaSRrel_c(length(CaSRrel_c));
Cadt0=Cadt(length(Cadt));
F1t0=F1t(length(F1t));
F2t0=F2t(length(F2t));
F3t0=F3t(length(F3t));
F4t0=1-F1t0-F2t0-F3t0;
rt0=rt(length(rt));
st0=st(length(st));
h_Ito_slow0=h_Ito_slow(length(h_Ito_slow));
rsts0=rsts(length(rsts)); 
rstt0=rstt(length(rstt)); 
ExBUFFERdt_free0=ExBUFFERdt_free(length(ExBUFFERdt_free));
ExBUFFERdt_Ca0=ExBUFFERdt_Ca(length(ExBUFFERdt_Ca));
ExBUFFERst_free0=ExBUFFERst_free(length(ExBUFFERst_free));
ExBUFFERst_Ca0=ExBUFFERst_Ca(length(ExBUFFERst_Ca));
Cac0=Cac(length(Cac));
Nac0=Nac(length(Nac));
Kc0=Kc(length(Kc));
ExBUFFERc_free0=ExBUFFERc_free(length(ExBUFFERc_free));
ExBUFFERc_Ca0=ExBUFFERc_Ca(length(ExBUFFERc_Ca));
CaSRrel_s0=CaSRrel_s(length(CaSRrel_s));    
F1s0=F1s(length(F1s));
F2s0=F2s(length(F2s));
F3s0=F3s(length(F3s));
F4s0=1-F1s0-F2s0-F3s0;
Cads0=Cads(length(Cads));
Kss0=Kss(length(Kss));
Nass0=Nass(length(Nass));
Cass0=Cass(length(Cass));
ExBUFFERds_free0=ExBUFFERds_free(length(ExBUFFERds_free));
ExBUFFERds_Ca0=ExBUFFERds_Ca(length(ExBUFFERds_Ca));
ExBUFFERss_free0=ExBUFFERss_free(length(ExBUFFERss_free));
ExBUFFERss_Ca0=ExBUFFERss_Ca(length(ExBUFFERss_Ca));
Cat_20=Cat_2(length(Cat_2));
Cat_30=Cat_3(length(Cat_3));
Cat_40=Cat_4(length(Cat_4));
Cat_50=Cat_5(length(Cat_5));
Cat_60=Cat_6(length(Cat_6));
Cat_70=Cat_7(length(Cat_7));
Cat_80=Cat_8(length(Cat_8));
Cat_90=Cat_9(length(Cat_9));
Kt_20=Kt_2(length(Kt_2));
Kt_30=Kt_3(length(Kt_3));
Kt_40=Kt_4(length(Kt_4));
Kt_50=Kt_5(length(Kt_5));
Kt_60=Kt_6(length(Kt_6));
Kt_70=Kt_7(length(Kt_7));
Kt_80=Kt_8(length(Kt_8));
Kt_90=Kt_9(length(Kt_9));



%Recalculation of membrane currents for graphical output*****************
ENas=log(Nae./Nass)*R*T/F;
EKs=log(Ke./Kc)*R*T/F;
ECas=log(Cae./Cass)*R*T/(2*F);
  
INas=gNas*ms.*ms.*ms.*hs.*(Vms-log((Nae+0.12*Ke)./(Nass+0.12*Kc))*R*T/F);
INat=0;

IKsCas=PKsCas*F^2/(R*T)*Vms.*(Kc-Ke*exp(-Vms*F/(R*T)))./(1-exp(-Vms.*F/(R*T)))./(1+(0.002./Cass).^4);
IKsCat=0;

ICads=PCads*4*(Vms*F^2/(R*T)).*(0.001.*exp(2*Vms*F/(R*T))-0.341*Cae)./(exp(2*Vms*F/(R*T))-1).*VDA_s.*VDI_s.*(1-CDI_ds);
ICas=PCas*4*(Vms*F^2/(R*T)).*(0.001.*exp(2*Vms*F/(R*T))-0.341*Cae)./(exp(2*Vms*F/(R*T))-1).*VDA_s.*VDI_s.*(1-CDI_ss);
IKls=0;
IKlt=0;

INals=0;
INalt=0;
  
IKtos_fast=PKtos*F^2/(R*T)*Vms.*(Kc-Ke*exp(-Vms*F/(R*T)))./(1-exp(-Vms.*F/(R*T))).*m_Ito_fast.*h_Ito_fast;
IKtos_slow=PKtos*0.62*F^2/(R*T)*Vms.*(Kc-Ke*exp(-Vms*F/(R*T)))./(1-exp(-Vms.*F/(R*T))).*m_Ito_slow.*h_Ito_slow;
IKtos=IKtos_fast+IKtos_slow;
IKtot=0;

IKsss=PKsss*F^2/(R*T)*Vms.*(Kc-Ke*exp(-Vms*F/(R*T)))./(1-exp(-Vms.*F/(R*T)))./(1+exp(-(Vms+3)./27));
IKsst=0;

IKachs=gKachs*(1+18.75/(1+0.00913652^0.47781/Achs^0.47781))./(1+exp((Vms+145.699)./41.66)).*(Vms-EKs); 
IKacht=0;

IK1s=gK1s*(Vms-EKs)./(1+exp(2.04*F/(R*T)*(Vms-EKs))*(1.0+exp((Ke-0.9988)/-0.124)));
IK1t=0;

IKsNas=gKsNas*(0.8-(0.65./(1+exp((Vms+125)/15))))*0.85./(1+(66./Nass).^2.8).*(Vms-EKs);
IKsNat=0;

InsNas=PnsNas*Vms*F^2/(R*T).*(0.75*Nass.*exp(Vms*F/(R*T))-0.75*Nae)./(exp(Vms*F/(R*T))-1)./(1+(0.0025./Cass).^3);
InsNat=0;

InsKs=PnsKs*Vms*F^2/(R*T).*(0.75*Kc.*exp(Vms*F/(R*T))-0.75*Ke)./(exp(Vms*F/(R*T))-1)./(1+(0.0025./Cass).^3);
InsKt=0;

INabs=gNabs*(Vms-ENas);
INabt=0;

ICabs=gCabs*(Vms-ECas);
ICabt=0;

IKbs=gKbs*(Vms-EKs);
IKbt=0;

INaCas=INaCamaxs*(exp(0.0187*Vms).*Nass.^3.*Cae-exp(-0.0187*Vms).*Nae.^3.*Cass)./(1+0.0001*(Nae.^3.*Cass+Nass.^3.*Cae));
INaCads=INaCamaxds*(exp(0.0187*Vms).*Nass.^3.*Cae-exp(-0.0187*Vms).*Nae.^3.*Cads)./(1+0.0001*(Nae.^3.*Cads+Nass.^3.*Cae));
INaCat=0;
INaCadt=0;

INaKs=INaKmaxs./(1+0.1245*exp(-0.1*Vms*F/(R*T))+0.0365*1/7*(exp(Nae/67.3)-1)*exp(-Vms*F/(R*T)))*1./(1+(10./Nass).^2)*Ke/(Ke+1.5);
INaKt=0;

IpCas=IpCamaxs*Cass./(0.0004+Cass);
IpCat=0;

IKatps=gKatps*1/(1+(ATPi/0.114)^2)*(Ke/4)^0.24.*(Vms-EKs); 
IKatpt=0;

if VCLAMP==1 
   Im=1000*(Vel-Vms)/Rel;  
end;


 
%Data for output file*************
if Results==1 && Tt(1)>=Graph_time
   RM=[Tt,Vms,CaSRup,Cac];   
   RMT=[RMT; RM];
end;



%Graphical output***
if Tt(1)>=Graph_time
figure(1)   
subplot(321);
plot(Tt,Vms)
ylabel('Vm [mV]');
hold on;

subplot(322);
plot(Tt,IKsss/Cms)
ylabel('IKss [pA/pF]');
hold on;

subplot(323);
plot(Tt,ICas/Cms,Tt,ICads/Cms)
ylabel('ICa, ICa_d [pA/pF]');
hold on;

subplot(324);
plot(Tt,IK1s/Cms)
ylabel('IK1 [pA/pF]');
hold on;

subplot(325);
plot(Tt,IKtos/Cms)
ylabel('IKto [pA/pF]');
xlabel('t [s]');
hold on;

subplot(326);
plot(Tt,IKachs/Cms)
ylabel('IKach [pA/pF]');
xlabel('t [s]');
hold on;


    
figure (2)
subplot(321);
plot(Tt,INaCas/Cms,Tt,INaCads/Cms);
ylabel('INaCa, INaCa_d [pA/pF]');
hold on;

subplot(322);
plot(Tt,ICabs/Cms)
ylabel('ICab [pA/pF]');
hold on;

subplot(323);
plot(Tt,INaKs/Cms)
ylabel('INaK [pA/pF]');
hold on;

subplot(324);
plot(Tt,IKbs/Cms)
ylabel('IKb [pA/pF]');
hold on;

subplot(325);
plot(Tt,IpCas/Cms)
ylabel('IpCa [pA/pF]');
xlabel('t [s]');
hold on;

subplot(326);
plot(Tt,INabs/Cms)
ylabel('INab [pA/pF]');
xlabel('t [s]');
hold on;
 


figure (3)
subplot(321);
plot(Tt,Cads*1E3)
ylabel('Ca_d [\muM]');
hold on;

subplot(322);
plot(Tt,Cass*1E3,Tt,Cac*1E3,'r')
ylabel('Ca_s, Ca_c [\muM]');
hold on;

subplot(323);
plot(Tt,CaSRup)
ylabel('Ca_N_S_R [mM]');
xlabel('t [s]');
hold on;

subplot(324);
plot(Tt,Kss,Tt,Kc,'r')
ylabel('K_s, K_c [mM]');
hold on;

subplot(325);
plot(Tt,CaSRrel_s,Tt,CaSRrel_c)
ylabel('Ca_J_S_R_s_/_J_S_R_c_o_r_b [mM]');
xlabel('t [s]');
hold on;

subplot(326);
plot(Tt,Nass,Tt,Nac,'r')
ylabel('Na_s, Na_c [mM]');
xlabel('t [s]');
hold on;



figure(4)   
subplot(221);
plot(Tt,Vms,'r');
ylabel('Vm [mV]');
hold on;

subplot(222);
plot(Tt,CaSRup,'r')
ylabel('Ca_N_S_R [mM]');
hold on;

subplot(223);
plot(Tt,IKachs/Cms,'r')
ylabel('IKach [pA/pF]');
xlabel('t [s]');
hold on;

subplot(224);
plot(Tt,Cac*1E3,'r')
ylabel('Ca_c [\muM]');
xlabel('t [s]');
hold on;



if VCLAMP==1
figure(5)
plot(Tt,Im/Cms,'r');
ylabel('Im [pA/pF]');
xlabel('t [s]');
hold on;
end;
end;